#include <iostream>
#include <ctime>
#include <cassert>
#include <cmath>
#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include "circle.h"
#include "assert.h"
#include "ezwin.h"
#include "bitmap.h"
#define LENGTH 25.0
#define HEIGHT 15.0
#define LENGTHINT 25

using namespace std;

int m,i=0,k,l,r=0,u,v,x=40,reached=0,score=0;
int left1[10],bullets[10],random1[2];
float angle,canonx,canony,j;
float soldierx[10],soldiery[10],bulletx[10],bullety[10],bulleta[10];
char s[4],a,p;

void startwindow();
void game();
void endwindow();

SimpleWindow initialwindow("Paratroopers",LENGTH,HEIGHT,Position(0.0,0.0));

int NB_ENABLE=0,NB_DISABLE=1;

void nonblock(int state)
{
    struct termios ttystate;
 
    //get the terminal state
    tcgetattr(STDIN_FILENO, &ttystate);
 
    if (state==NB_ENABLE)
    {
        //turn off canonical mode
        ttystate.c_lflag &= ~ICANON;
        //minimum of number input read.
        ttystate.c_cc[VMIN] = 1;
    }
    else if (state==NB_DISABLE)
    {
        //turn on canonical mode
        ttystate.c_lflag |= ICANON;
    }
    //set the terminal attributes.
    tcsetattr(STDIN_FILENO, TCSANOW, &ttystate);
 
}
int kbhit()
{
    struct timeval tv;
    fd_set fds;
    tv.tv_sec = 0;
    tv.tv_usec = 0;
    FD_ZERO(&fds);
    FD_SET(STDIN_FILENO, &fds); //STDIN_FILENO is 0
    select(STDIN_FILENO+1, &fds, NULL, NULL, &tv);
    return FD_ISSET(STDIN_FILENO, &fds);
}

/*int check(const Position &p)
{
int x=0,y=0;
x=p.GetXDistance();
y=p.GetYDistance();
if((x>=27.0&&x<=28.0)&&(y>=17.0&&y<=18.0))//checking whether click is in box left
return 3; 
else if((x>=28.5&&x<=29.5)&&(y>=17.0&&y<=18.0))//checking whether click is in box right
return 2;
else if((x>=27.0&&x<=18.5)&&(y>=29.5&&y<=19.5))//checking whether click is in box fire
return 1;
else return 0;
}*/

/*int check2(const Position &p)
{
	int x=0,y=0;
x=p.GetXDistance();
y=p.GetYDistance();
if((x>=0.0&&x<=0.5)&&(y>=0.0&&y<=0.5))
{c=1;}
else c= 0;
}

int kbhit()
{
  struct termios oldt, newt;
  int ch;
  int oldf;
 
  tcgetattr(STDIN_FILENO, &oldt);
  newt = oldt;
  newt.c_lflag &= ~(ICANON | ECHO);
  tcsetattr(STDIN_FILENO, TCSANOW, &newt);
  oldf = fcntl(STDIN_FILENO, F_GETFL, 0);
  fcntl(STDIN_FILENO, F_SETFL, oldf | O_NONBLOCK);
 
  ch = getchar();
   p = ch;
  tcsetattr(STDIN_FILENO, TCSANOW, &oldt);
  fcntl(STDIN_FILENO, F_SETFL, oldf);
 
  if(ch != EOF)
  {
    ungetc(ch, stdin);
    return 1;
  }
 
  return 0;
}


int kbhit (void)
{
  struct timeval tv;
  fd_set rdfs;
 
  tv.tv_sec = 0;
  tv.tv_usec = 0;
 
  FD_ZERO(&rdfs);
  FD_SET (STDIN_FILENO, &rdfs);
 
  select(STDIN_FILENO+1, &rdfs, NULL, NULL, &tv);
  return FD_ISSET(STDIN_FILENO, &rdfs);
 
}*/

char getch() 
{
        char buf = 0;
        struct termios old = {0};
        if (tcgetattr(0, &old) < 0)
                perror("tcsetattr()");
        old.c_lflag &= ~ICANON;
        old.c_lflag &= ~ECHO;
        old.c_cc[VMIN] = 1;
        old.c_cc[VTIME] = 0;
        if (tcsetattr(0, TCSANOW, &old) < 0)
                perror("tcsetattr ICANON");
        if (read(0, &buf, 1) < 0)
                perror ("read()");
        old.c_lflag |= ICANON;
        old.c_lflag |= ECHO;
        if (tcsetattr(0, TCSADRAIN, &old) < 0)
                perror ("tcsetattr ~ICANON");
	fflush(stdin);
        return (buf);
}

void endwindow(){
	sleep(1);

	BitMap Photo1(initialwindow);
	Photo1.Load("paraend.xpm");
	assert(Photo1.GetStatus()==BitMapOkay);
	Position PhotoPosition=(0.0,0.0);
	Photo1.SetPosition(PhotoPosition);
	Photo1.Draw();
	
	initialwindow.RenderText((10.0,10.0),(20.0,15.0),s,Black);

	a = getch();
	if(a=27){//esc to exit
	    sleep(1);
	    initialwindow.Close();
	}

	if(a=113){//q to restart
	    sleep(1);
	    game();
	}
}



void game()
{   
	/*BitMap Photo1(initialwindow);//load the background photo
	Photo1.Load("Back.bmp");
	assert(Photo1.GetStatus()==BitMapOkay);
	Position Photo1Position=(0.0,0.0);
	Photo1.SetPosition(Photo1Position);
	Photo1.Draw();*/
	BitMap Photo(initialwindow);	
	Photo.Erase();
	Position Rectanglebase=Position(0.5*LENGTH,HEIGHT);//Center base of rectangle
	Position CircleCenter=Rectanglebase + Position(0.0,-1.0);//1.0 is height of ractangle
	CircleShape C(initialwindow,CircleCenter,Blue,2);
	C.Draw();
	Position UpperCorner=Rectanglebase + Position(-1.0, -1.0);//check the length 2 len 2 height
	Position LowerCorner=Rectanglebase + Position(1.0, 0.0);
	initialwindow.RenderRectangle(UpperCorner,LowerCorner,Blue,true);
	
	/*initialwindow.RenderRectangle((27.0,17.0),(28.0,18.0),White,true);
	initialwindow.RenderText((27.0,17.0),(28.0,18.0),"LEFT",Black);
	initialwindow.RenderRectangle((28.5,17.0),(29.5,18.0),White,true);
	initialwindow.RenderText((28.5,17.0),(29.5,18.0),"RIGHT",Black);
	initialwindow.RenderRectangle((27.0,18.5),(29.5,19.5),White,true);
	initialwindow.RenderText((27,18.5),(29.5,19.5),"FIRE",Black);
	initialwindow.RenderRectangle(Position(0.0,0.0),Position(0.5,0.5),White,true);
	initialwindow.RenderText(Position(0.0,0.0),Position(0.5,0.5),"II",Red);*/
	
	/*BitMap para0(initialwindow);
	BitMap land0(initialwindow);
	BitMap died0(initialwindow);
	BitMap bullet0(initialwindow);
	BitMap para1(initialwindow);
	BitMap land1(initialwindow);
	BitMap died1(initialwindow);
	BitMap bullet1(initialwindow);
	BitMap para2(initialwindow);
	BitMap land2(initialwindow);
	BitMap died2(initialwindow);
	BitMap bullet2(initialwindow);
	BitMap para3(initialwindow);
	BitMap land3(initialwindow);
	BitMap died3(initialwindow);
	BitMap bullet3(initialwindow);
	BitMap para4(initialwindow);
	BitMap land4(initialwindow);
	BitMap died4(initialwindow);
	BitMap bullet4(initialwindow);
	BitMap para5(initialwindow);
	BitMap land5(initialwindow);
	BitMap died5(initialwindow);
	BitMap bullet5(initialwindow);
	BitMap para6(initialwindow);
	BitMap land6(initialwindow);
	BitMap died6(initialwindow);
	BitMap bullet6(initialwindow);
	BitMap para7(initialwindow);
	BitMap land7(initialwindow);
	BitMap died7(initialwindow);
	BitMap bullet7(initialwindow);
	BitMap para8(initialwindow);
	BitMap land8(initialwindow);
	BitMap died8(initialwindow);
	BitMap bullet8(initialwindow);
	BitMap para9(initialwindow);
	BitMap land9(initialwindow);
	BitMap died9(initialwindow);
	BitMap bullet9(initialwindow);*/
	
	BitMap Photo_heli(initialwindow);//load the helicopter photo
	Photo_heli.Load("copter.xpm");
	assert(Photo_heli.GetStatus()==BitMapOkay);
		
	//loading part (photo.load) for 20 soldiers

	BitMap para0(initialwindow);
	para0.Load("paratrooper.xpm");
	assert(para0.GetStatus()==BitMapOkay);
	BitMap land0(initialwindow);//load the landed soldier photo
	land0.Load("landtrooper.xpm");
	assert(land0.GetStatus()==BitMapOkay);
	BitMap died0(initialwindow);//load the dead soldier photo
	died0.Load("landtrooper.xpm");
	assert(died0.GetStatus()==BitMapOkay);
	BitMap bullet0(initialwindow);//load the bullet photo
	bullet0.Load("landtrooper.xpm");
	assert(bullet0.GetStatus()==BitMapOkay);

	BitMap para1(initialwindow);
	para1.Load("paratrooper.xpm");
	assert(para1.GetStatus()==BitMapOkay);
	BitMap land1(initialwindow);//load the landed soldier photo
	land1.Load("landtrooper.xpm");
	assert(land1.GetStatus()==BitMapOkay);
	BitMap died1(initialwindow);//load the dead soldier photo
	died1.Load("landtrooper.xpm");
	assert(died1.GetStatus()==BitMapOkay);
	BitMap bullet1(initialwindow);//load the bullet photo
	bullet1.Load("landtrooper.xpm");
	assert(bullet1.GetStatus()==BitMapOkay);

	BitMap para2(initialwindow);
	para2.Load("paratrooper.xpm");
	assert(para2.GetStatus()==BitMapOkay);
	BitMap land2(initialwindow);//load the landed soldier photo
	land2.Load("landtrooper.xpm");
	assert(land2.GetStatus()==BitMapOkay);
	BitMap died2(initialwindow);//load the dead soldier photo
	died2.Load("landtrooper.xpm");
	assert(died2.GetStatus()==BitMapOkay);
	BitMap bullet2(initialwindow);//load the bullet photo
	bullet2.Load("landtrooper.xpm");
	assert(bullet2.GetStatus()==BitMapOkay);

	BitMap para3(initialwindow);
	para3.Load("paratrooper.xpm");
	assert(para3.GetStatus()==BitMapOkay);
	BitMap land3(initialwindow);//load the landed soldier photo
	land3.Load("landtrooper.xpm");
	assert(land3.GetStatus()==BitMapOkay);
	BitMap died3(initialwindow);//load the dead soldier photo
	died3.Load("landtrooper.xpm");
	assert(died3.GetStatus()==BitMapOkay);
	BitMap bullet3(initialwindow);//load the bullet photo
	bullet3.Load("landtrooper.xpm");
	assert(bullet3.GetStatus()==BitMapOkay);

	BitMap para4(initialwindow);
	para4.Load("paratrooper.xpm");
	assert(para4.GetStatus()==BitMapOkay);
	BitMap land4(initialwindow);//load the landed soldier photo
	land4.Load("landtrooper.xpm");
	assert(land4.GetStatus()==BitMapOkay);
	BitMap died4(initialwindow);//load the dead soldier photo
	died4.Load("landtrooper.xpm");
	assert(died4.GetStatus()==BitMapOkay);
	BitMap bullet4(initialwindow);//load the bullet photo
	bullet4.Load("landtrooper.xpm");
	assert(bullet4.GetStatus()==BitMapOkay);

	BitMap para5(initialwindow);
	para5.Load("paratrooper.xpm");
	assert(para5.GetStatus()==BitMapOkay);
	BitMap land5(initialwindow);//load the landed soldier photo
	land5.Load("landtrooper.xpm");
	assert(land5.GetStatus()==BitMapOkay);
	BitMap died5(initialwindow);//load the dead soldier photo
	died5.Load("landtrooper.xpm");
	assert(died5.GetStatus()==BitMapOkay);
	BitMap bullet5(initialwindow);//load the bullet photo
	bullet5.Load("landtrooper.xpm");
	assert(bullet5.GetStatus()==BitMapOkay);

	BitMap para6(initialwindow);
	para6.Load("paratrooper.xpm");
	assert(para6.GetStatus()==BitMapOkay);
	BitMap land6(initialwindow);//load the landed soldier photo
	land6.Load("landtrooper.xpm");
	assert(land6.GetStatus()==BitMapOkay);
	BitMap died6(initialwindow);//load the dead soldier photo
	died6.Load("landtrooper.xpm");
	assert(died6.GetStatus()==BitMapOkay);
	BitMap bullet6(initialwindow);//load the bullet photo
	bullet6.Load("landtrooper.xpm");
	assert(bullet6.GetStatus()==BitMapOkay);

	BitMap para7(initialwindow);
	para7.Load("paratrooper.xpm");
	assert(para7.GetStatus()==BitMapOkay);
	BitMap land7(initialwindow);//load the landed soldier photo
	land7.Load("landtrooper.xpm");
	assert(land7.GetStatus()==BitMapOkay);
	BitMap died7(initialwindow);//load the dead soldier photo
	died7.Load("landtrooper.xpm");
	assert(died7.GetStatus()==BitMapOkay);
	BitMap bullet7(initialwindow);//load the bullet photo
	bullet7.Load("landtrooper.xpm");
	assert(bullet7.GetStatus()==BitMapOkay);

	BitMap para8(initialwindow);
	para8.Load("paratrooper.xpm");
	assert(para8.GetStatus()==BitMapOkay);
	BitMap land8(initialwindow);//load the landed soldier photo
	land8.Load("landtrooper.xpm");
	assert(land8.GetStatus()==BitMapOkay);
	BitMap died8(initialwindow);//load the dead soldier photo
	died8.Load("landtrooper.xpm");
	assert(died8.GetStatus()==BitMapOkay);
	BitMap bullet8(initialwindow);//load the bullet photo
	bullet8.Load("landtrooper.xpm");
	assert(bullet8.GetStatus()==BitMapOkay);

	BitMap para9(initialwindow);
	para9.Load("paratrooper.xpm");
	assert(para9.GetStatus()==BitMapOkay);
	BitMap land9(initialwindow);//load the landed soldier photo
	land9.Load("landtrooper.xpm");
	assert(land9.GetStatus()==BitMapOkay);
	BitMap died9(initialwindow);//load the dead soldier photo
	died9.Load("landtrooper.xpm");
	assert(died9.GetStatus()==BitMapOkay);
	BitMap bullet9(initialwindow);//load the bullet photo
	bullet9.Load("landtrooper.xpm");
	assert(bullet9.GetStatus()==BitMapOkay);

 nonblock(NB_ENABLE);
while (1)
{
srand((unsigned int)time((time_t *)NULL));
for(i=0;i<2;i++){//for random places where soilders drops
 random1[i] = rand()%25;} //define variables as global and float    ....here lengthint needed as % works with int ...length n lengthint will hv same value
for(j=0.0;j<LENGTH+10;j+=1.0) //0.1 is increment check if smaller increment is needed
    {
	BitMap Photo_heli(initialwindow);
	Position Photo_heliPosition=Position(j,0.0);//height of helicopter is 2.0
	Photo_heli.SetPosition(Photo_heliPosition);
	Photo_heli.Draw();
	m=j;
 for(i=0;i<2;i++)//drawing photograph of soldiers
 {
  if(random1[i]==m && m<=LENGTHINT)
  {
   if(k==10){//initialize k as global variable and it is 0 
	k=0;}//after 21 soldiers it overwrites assuming 21 soilders reach canon or die in way
	soldierx[k]=random1[i];
	soldiery[k]=2.0;
	left1[k]=1;//whether a particular soilder has to come down intial val is 0
	k++;
  }
}


for(l=0;l<9;l++){

 if(left1[l]==1)//checking whether soldier has to come down n alive by default v set it to 0 means not yet started to fall
     {
	soldiery[l]+=1.0;
	
	if(l==0){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para0.SetPosition(Photo_paraPosition);
	para0.Draw();}
	if(l==1){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para1.SetPosition(Photo_paraPosition);
	para1.Draw();}
	if(l==2){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para2.SetPosition(Photo_paraPosition);
	para2.Draw();}
	if(l==3){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para3.SetPosition(Photo_paraPosition);
	para3.Draw();}
	if(l==4){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para4.SetPosition(Photo_paraPosition);
	para4.Draw();}
	if(l==5){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para5.SetPosition(Photo_paraPosition);
	para5.Draw();}
	if(l==6){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para6.SetPosition(Photo_paraPosition);
	para6.Draw();}
	if(l==7){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para7.SetPosition(Photo_paraPosition);
	para7.Draw();}
	if(l==8){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para8.SetPosition(Photo_paraPosition);
	para8.Draw();}
	if(l==9){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para9.SetPosition(Photo_paraPosition);
	para9.Draw();}

	if(soldiery[l]>=HEIGHT-2)//checking if soldier reached bottom
	{
	left1[l]=2;//2 indicates it is at ground
	}
   }
 
 if(left1[l]==2)//2 indicates it is at ground
      {
	if (soldierx[l]>11.5)
	{
      	soldierx[l]-=2.0;
	}
	else if (soldierx[l]<13.5)
	{
      	soldierx[l]+=2.0;
	}
	else if (soldierx[l]>=11.5&&soldierx[l]<=13.5)
	 {
	 reached++;
	 if(reached==5){//assuming if 5 reaches game ends
	   endwindow();//this will manage task of ending the program
	    }
	}

	if(l==0){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land0.SetPosition(Photo_landPosition);
	land0.Draw();}
	if(l==1){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land1.SetPosition(Photo_landPosition);
	land1.Draw();}
	if(l==2){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land2.SetPosition(Photo_landPosition);
	land2.Draw();}
	if(l==3){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land3.SetPosition(Photo_landPosition);
	land3.Draw();}
	if(l==4){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land4.SetPosition(Photo_landPosition);
	land4.Draw();}
	if(l==5){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land5.SetPosition(Photo_landPosition);
	land5.Draw();}
	if(l==6){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land6.SetPosition(Photo_landPosition);
	land6.Draw();}
	if(l==7){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land7.SetPosition(Photo_landPosition);
	land7.Draw();}
	if(l==8){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land8.SetPosition(Photo_landPosition);
	land8.Draw();}
	if(l==9){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land9.SetPosition(Photo_landPosition);
	land9.Draw();}


   }

	
if(left1[l]==3)//checking whether soldier has to come down not alive 
	{
	soldiery[l]+=0.2;//increament can be changed to move dead soldier faster
	
	if(l==0){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died0.SetPosition(Photo_diedPosition);
	died0.Draw();}
	if(l==1){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died1.SetPosition(Photo_diedPosition);
	died1.Draw();}
	if(l==2){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died2.SetPosition(Photo_diedPosition);
	died2.Draw();}
	if(l==3){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died3.SetPosition(Photo_diedPosition);
	died3.Draw();}
	if(l==4){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died4.SetPosition(Photo_diedPosition);
	died4.Draw();}
	if(l==5){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died5.SetPosition(Photo_diedPosition);
	died5.Draw();}
	if(l==6){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died6.SetPosition(Photo_diedPosition);
	died6.Draw();}
	if(l==7){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died7.SetPosition(Photo_diedPosition);
	died7.Draw();}
	if(l==8){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died8.SetPosition(Photo_diedPosition);
	died8.Draw();}
	if(l==9){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died9.SetPosition(Photo_diedPosition);
	died9.Draw();}

	}
}

/*	q:
	a=initialwindow.SetMouseClickCallback(check);

 /*  if (a==0)
	{
	goto q;
	}
*/
  i=kbhit();
if(i!=0){
p=fgetc(stdin);
     if(p==32){//space to fire
	if(r==10){
	    r=0;
	  }
	bullets[r]=1;
	bulleta[r]=x;
	bulletx[r]=canonx;
	bullety[r]=canony;
	r++;
    }

    if(p==107&& x>=20){//k for right
	x--;
    }

   else if(p==106 && x<=60){//j for left
	x++;
    }
   else if(p==27){//esc to exit
	initialwindow.Close();
    }

   else if(p==113){//q to restart
	startwindow();
    }

   else if(p==119){//w to pause
	initialwindow.RenderText(Position(8.0,10.0),Position(17.0,13.0),"PRESS ANY KEY TO START",Black);
	getch();
	initialwindow.RenderRectangle(Position(8.0,10.0),Position(17.0,13.0),White,false);
}   
}

	/*initialwindow.RenderLine(Position(12.5,19.0),Position(canonx+(canonx-12.5)/2,canony+(canony-19.0)/2),Blue, 0.1);
	initialwindow.RenderLine(Position(canonx+(canonx-12.5)/2,canony+(canony-19.0)/2),Position(canonx,canony),White, 0.1);*/
	initialwindow.RenderLine(Position(12.5,14.0),Position(canonx,canony),White, 0.1);
	Position Rectanglebase=Position(0.5*LENGTH,HEIGHT);//Center base of rectangle
	Position CircleCenter=Rectanglebase + Position(0.0,-1.0);//1.0 is height of ractangle
	CircleShape C(initialwindow,CircleCenter,Blue,2);
	C.Draw();
	Position UpperCorner=Rectanglebase + Position(-1.0, -1.0);//check the length 2 len 2 height
	Position LowerCorner=Rectanglebase + Position(1.0, 0.0);
	initialwindow.RenderRectangle(UpperCorner,LowerCorner,Blue,true);
	
	angle=x*3.14/40;
	canonx=12.5+1.5*sin(angle);
	canony=14.0+1.5*cos(angle);
	initialwindow.RenderLine(Position(12.5,14.0),Position(canonx,canony),Black, 0.1);

  for(u=0;u<10;u++){

//	sprintf(ch,"bullet%d",u);	
	if(bullets[u]==1)//bullet moving on
	{
	bulletx[u]+=2.0*sin(bulleta[u]*3.14/40);
	bullety[u]-=2.0*cos(bulleta[u]*3.14/40);

	if(u==0){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet0.SetPosition(bulletPosition);
	bullet0.Draw();}
	if(u==1){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet1.SetPosition(bulletPosition);
	bullet1.Draw();}
	if(u==2){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet2.SetPosition(bulletPosition);
	bullet2.Draw();}
	if(u==3){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet3.SetPosition(bulletPosition);
	bullet3.Draw();}
	if(u==4){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet4.SetPosition(bulletPosition);
	bullet4.Draw();}
	if(u==5){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet5.SetPosition(bulletPosition);
	bullet5.Draw();}
	if(u==6){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet6.SetPosition(bulletPosition);
	bullet6.Draw();}
	if(u==7){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet7.SetPosition(bulletPosition);
	bullet7.Draw();}
	if(u==8){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet8.SetPosition(bulletPosition);
	bullet8.Draw();}
	if(u==9){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet9.SetPosition(bulletPosition);
	bullet9.Draw();}
	
	}

/*	if(bullets[u]==2)//bullet moving on
	{
	BitMap ch(initialwindow);
	ch.Erase();
	}
	/*if(bulletx[u]<=0.0||bulletx[u]>=30.0||bullety[u]<=2.0)
	{
	bullet[u].Erase;
	}
    }
*/}	
for(u=0;u<10;u++)//for each bullet
{
    for(v=0;v<10;v++)//for each soldier
     {
	if((bulletx[u]>=(soldierx[v]-0.2)&&bulletx[u]<=(soldierx[v]+0.2))&&(bullety[u]>=(soldiery[v]-0.2)&&bullety[u]<=(soldiery[v]+0.2)))
	{
	score+=20;//each soldier shot makes score increase by 20
	bullets[u]=2;
	left1[v]=3;
	}
     }
}
Photo_heli.Erase();

para0.Erase();
land0.Erase();
died0.Erase();
bullet0.Erase();
para1.Erase();
land1.Erase();
died1.Erase();
bullet1.Erase();
para2.Erase();
land2.Erase();
died2.Erase();
bullet2.Erase();
para3.Erase();
land3.Erase();
died3.Erase();
bullet3.Erase();
para4.Erase();
land4.Erase();
died4.Erase();
bullet4.Erase();
para5.Erase();
land5.Erase();
died5.Erase();
bullet5.Erase();
para6.Erase();
land6.Erase();
died6.Erase();
bullet6.Erase();
para7.Erase();
land7.Erase();
died7.Erase();
bullet7.Erase();
para8.Erase();
land8.Erase();
died8.Erase();
bullet8.Erase();
para9.Erase();
land9.Erase();
died9.Erase();
bullet9.Erase();
}}
nonblock(NB_DISABLE);
}


/*int game1(const Position &p)
{
int x=0,y=0;
x=p.GetXDistance();//check whether it is right command
y=p.GetYDistance();//check whether it is right command
if((x>=12.0&&x<=18.0)&&(y>=13.0&&y<=17.0))//checking whether click is in box
{b= 1;} 
else b= 0;
}*/


void startwindow()
{
	BitMap Photo(initialwindow);
	Photo.Load("para.xpm");
	assert(Photo.GetStatus()==BitMapOkay);
	Position PhotoPosition=(2.0,2.0);
	Photo.SetPosition(PhotoPosition);
	Photo.Draw();
	/*can include tabs afterwards
	Position UpperCorner=(12.0,13.0);
	Position LowerCorner=(18.0,17.0);
	initialwindow.RenderRectangle(UpperCorner,LowerCorner,White);
	initialwindow.RenderText(UpperCorner,LowerCorner,"START",Black);
	p:
	b=initialwindow.SetMouseClickCallback(game1);//check whether it gives error on not returning value to any variable
    if (b==1)
	  game();
	 else
	  goto p;*/
//initialwindow.RenderText(Position(8.0,15.0),Position(17.0,18.0),"PRESS ANY KEY TO START",Black);
getch();
//sleep(1);



Photo.Erase();
game();
}

int ApiMain()//define it at last
{
	initialwindow.Open();
	assert(initialwindow.GetStatus()==WindowOpen);


	startwindow();
	initialwindow.Close();
}




